#!/bin/sh

if [ ! -e jami-daemon ]; then
  git clone https://git.jami.net/savoirfairelinux/jami-daemon.git
else
  cd jami-daemon
    git pull
  cd -
fi

cd jami-daemon
git pull
  DATE=$(git log -1 --format="%cd" --date=short | sed "s|-||g")
  git config tar.tar.xz.command "xz -v -T0 -9e -c"
  git archive --format=tar.xz -o ../jami-daemon-${DATE}.tar.xz --prefix=jami-daemon-${DATE}/ master
cd -

version=$(head -2 jami-daemon/meson.build | grep "version:" | awk '{print $2}' | sed -e 's@,@@g' -e 's@\x27@@g')
echo "jami-daemon version: $version, please upgrade this value to SPEC file if version has changed"
